# 32/64bit spec
#
%define _disable_ld_no_undefined 1

%define _localstatedir 	 /var/run

%define mod_gss_version 1.3.5
%define mod_autohost_version 0.4
%define mod_case_version 0.7
%define mod_shaper_version 0.6.5
%define mod_time_version 2.2.1
%define mod_vroot_version 0.9.2

Summary:	Professional FTP Server
Name:		proftpd
Version:	1.3.4e
Release:	%mkrel 1
License:	GPL
Group:		System/Servers
URL:		http://proftpd.org/
Source0:	ftp://ftp.proftpd.org/distrib/source/%{name}-%{version}.tar.xz
Source1:	proftpd.logrotate
Source2: 	proftpd.xinetd
Source3:	proftpd.init
Source4:	proftpd.service
Source5:	basic.conf
Source7:	welcome.msg
Source32:	32_mod_shaper.conf
Source100:	http://prdownloads.sourceforge.net/gssmod/mod_gss-%{mod_gss_version}.tar.xz
Source102:	http://www.castaglia.org/proftpd/modules/proftpd-mod-autohost-%{mod_autohost_version}.tar.xz
Source103:	http://www.castaglia.org/proftpd/modules/proftpd-mod-case-%{mod_case_version}.tar.xz
Source104:	http://www.castaglia.org/proftpd/modules/proftpd-mod-shaper-%{mod_shaper_version}.tar.xz
Source105:	http://www.castaglia.org/proftpd/modules/proftpd-mod-time-%{mod_time_version}.tar.xz
Source108:	http://www.castaglia.org/proftpd/modules/proftpd-mod-vroot-%{mod_vroot_version}.tar.xz
Source200:	anonymous.conf
Patch0:		proftpd-1.3.0-xferstats_logfile_location.diff
Patch2:		proftpd-use-system-auth-instead-of-pam_unix.diff
Patch4:		proftpd-1.3.0-installfix.diff
Patch7:		proftpd-1.3.0-change_pam_name.diff
Patch8:		proftpd-1.3.2-mod_time_fix.diff
Patch40:	mod_gss-1.3.0-format_not_a_string_literal_and_no_format_arguments.diff
Patch41:	mod_time-format_not_a_string_literal_and_no_format_arguments.diff
Requires:	pam
Requires:	setup
Requires(post): rpm-helper
Requires(postun): rpm-helper
Requires(preun): rpm-helper
Requires(pre): rpm-helper
BuildRequires:	cap-devel
BuildRequires:	gettext-devel
BuildRequires:	libacl-devel
BuildRequires:	libattr-devel
BuildRequires:	libkrb-devel
BuildRequires:	libtool
BuildRequires:	libtool-devel
BuildRequires:	mysql-devel
BuildRequires:	ncurses-devel
BuildRequires:	openldap-devel
BuildRequires:	openssl-devel
BuildRequires:	pam-devel
BuildRequires:	pkgconfig
BuildRequires:	postgresql-devel
BuildRequires:	sasl-plug-gssapi
BuildRequires:	tcp_wrappers-devel
BuildRequires:	zlib-devel
Provides:	ftpserver
Conflicts:	wu-ftpd
Conflicts:	ncftpd
Conflicts:	beroftpd
Conflicts:	anonftp
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-buildroot

%description
ProFTPd is an enhanced FTP server with a focus toward simplicity, security, and
ease of configuration.  It features a very Apache-like configuration syntax,
and a highly customizable server infrastructure, including support for multiple
'virtual' FTP servers, anonymous FTP, and permission-based directory
visibility.

This version supports both standalone and xinetd operation.

%package	devel
Summary:	Development files for ProFTPD
Group:		Development/Libraries

%description	devel
This package contains the development headers for ProFTPD

%package	mod_ctrls_admin
Summary:	Module implementing admin control handlers
Group:		System/Servers
Requires(post): %{name} = %{version}-%{release}
Requires(preun): %{name} = %{version}-%{release}
Requires:	%{name} = %{version}-%{release}

%description	mod_ctrls_admin
This module implements administrative control actions for the ftpdctl program.

%package	mod_ifsession
Summary:	Module supporting conditional per-user/group/class configuration contexts
Group:		System/Servers
Requires(post): %{name} = %{version}-%{release}
Requires(preun): %{name} = %{version}-%{release}
Requires:	%{name} = %{version}-%{release}

%description	mod_ifsession
Module supporting conditional per-user/group/class configuration contexts

%package	mod_ldap
Summary:	LDAP password lookup module for ProFTPD
Group:		System/Servers
Requires(post): %{name} = %{version}-%{release}
Requires(preun): %{name} = %{version}-%{release}
Requires:	%{name} = %{version}-%{release}

%description	mod_ldap
LDAP password lookup module for ProFTPD

%package	mod_quotatab
Summary:	Module for managing FTP byte/file quotas via centralized tables
Group:		System/Servers
Requires(post): %{name} = %{version}-%{release}
Requires(preun): %{name} = %{version}-%{release}
Requires:	%{name} = %{version}-%{release}
Requires:	%{name}-mod_quotatab_driver = %{version}-%{release}

%description	mod_quotatab
Module for managing FTP byte/file quotas via centralized tables

%package	mod_quotatab_file
Summary:	Sub-module for managing quota data via file-based tables
Group:		System/Servers
Requires(post): %{name} = %{version}-%{release}
Requires(preun): %{name} = %{version}-%{release}
Requires:	%{name}-mod_quotatab = %{version}-%{release}
Provides:	%{name}-mod_quotatab_driver = %{version}-%{release}

%description	mod_quotatab_file
Sub-module for managing quota data via file-based tables

%package	mod_quotatab_ldap
Summary:	Sub-module for obtaining quota information from an LDAP directory
Group:		System/Servers
Requires(post): %{name} = %{version}-%{release}
Requires(preun): %{name} = %{version}-%{release}
Requires:	%{name}-mod_quotatab = %{version}-%{release}
Provides:	%{name}-mod_quotatab_driver = %{version}-%{release}

%description	mod_quotatab_ldap
Sub-module for obtaining quota information from an LDAP directory

%package	mod_quotatab_sql
Summary:	Sub-module for managing quota data via SQL-based tables
Group:		System/Servers
Requires(post): %{name} = %{version}-%{release}
Requires(preun): %{name} = %{version}-%{release}
Requires:	%{name}-mod_quotatab = %{version}-%{release}
Provides:	%{name}-mod_quotatab_driver = %{version}-%{release}

%description	mod_quotatab_sql
Sub-module for managing quota data via SQL-based tables

%package	mod_quotatab_radius
Summary:	Sub-module for managing quota data via radius
Group:		System/Servers
Requires(post): %{name} = %{version}-%{release}
Requires(preun): %{name} = %{version}-%{release}
Requires:	%{name}-mod_quotatab = %{version}-%{release}
Provides:	%{name}-mod_quotatab_driver = %{version}-%{release}

%description	mod_quotatab_radius
Sub-module for managing quota data via radius

%package	mod_radius
Summary:	Module for RADIUS authentication and accounting
Group:		System/Servers
Requires(post): %{name} = %{version}-%{release}
Requires(preun): %{name} = %{version}-%{release}
Requires:	%{name} = %{version}-%{release}

%description	mod_radius
Module for RADIUS authentication and accounting

%package	mod_ratio
Summary:	Support upload/download ratios
Group:		System/Servers
Requires(post): %{name} = %{version}-%{release}
Requires(preun): %{name} = %{version}-%{release}
Requires:	%{name} = %{version}-%{release}

%description	mod_ratio
Support upload/download ratios

%package	mod_rewrite
Summary:	Module for rewriting FTP commands
Group:		System/Servers
Requires(post): %{name} = %{version}-%{release}
Requires(preun): %{name} = %{version}-%{release}
Requires:	%{name} = %{version}-%{release}

%description	mod_rewrite
Module for rewriting FTP commands

%package	mod_site_misc
Summary:	Module implementing miscellaneous SITE commands
Group:		System/Servers
Requires(post): %{name} = %{version}-%{release}
Requires(preun): %{name} = %{version}-%{release}
Requires:	%{name} = %{version}-%{release}

%description	mod_site_misc
Module implementing miscellaneous SITE commands

%package	mod_sql
Summary:	SQL frontend
Group:		System/Servers
Requires(post): %{name} = %{version}-%{release}
Requires(preun): %{name} = %{version}-%{release}
Requires:	%{name} = %{version}-%{release}
Requires:	%{name}-mod_sql_driver = %{version}-%{release}

%description	mod_sql
SQL frontend

%package	mod_sql_mysql
Summary:	Support for connecting to MySQL databases
Group:		System/Servers
Requires(post): %{name} = %{version}-%{release}
Requires(preun): %{name} = %{version}-%{release}
Requires:	%{name}-mod_sql = %{version}-%{release}
Provides:	%{name}-mod_sql_driver = %{version}-%{release}

%description	mod_sql_mysql
Support for connecting to MySQL databases

%package	mod_sql_postgres
Summary:	Support for connecting to Postgres databases
Group:		System/Servers
Requires(post): %{name} = %{version}-%{release}
Requires(preun): %{name} = %{version}-%{release}
Requires:	%{name}-mod_sql = %{version}-%{release}
Provides:	%{name}-mod_sql_driver = %{version}-%{release}

%description	mod_sql_postgres
Support for connecting to Postgres databases

%package	mod_tls
Summary:	An RFC2228 SSL/TLS module for ProFTPD
Group:		System/Servers
Requires(post): %{name} = %{version}-%{release}
Requires(preun): %{name} = %{version}-%{release}
Requires:	%{name} = %{version}-%{release}

%description	mod_tls
An RFC2228 SSL/TLS module for ProFTPD

%package	mod_autohost
Summary:	An autohost module for ProFTPD
Group:		System/Servers
Requires(post): %{name} = %{version}-%{release}
Requires(preun): %{name} = %{version}-%{release}
Requires:	%{name} = %{version}-%{release}

%description	mod_autohost
For sites that run a large number of <VirtualHost>s for proftpd, it can be
cumbersome to configure them all in the proftpd.conf file. Adding or removing
virtual server configurations require restarting the daemon, as do changes to
one of the server configurations. The daemon also consumes memory for each
server configuration, and the memory footprint for the daemon process can grow
large for large numbers of servers.

The mod_autohost module allows for server configurations to be configured in
individual files, and for those configuration to be used in an "on demand"
fashion. Rather than loading the configurations into memory when the daemon
starts up, the daemon will check the IP address and port being contacted by a
connecting client, check in the filesystem for a mod_autohost configuration
file for that address/port, dynamically parse the configuration, and insert
the configuration into the session's process space. Thus changes to the
configuration are seen whenever a client connects, without requiring a daemon
restart. The memory footprint is reduced because proftpd, via mod_autohost,
only reads and uses the needed configuration.

%package	mod_case
Summary:	Makes ProFTPD case insensitive
Group:		System/Servers
Requires(post): %{name} = %{version}-%{release}
Requires(preun): %{name} = %{version}-%{release}
Requires:	%{name} = %{version}-%{release}

%description	mod_case
The mod_case module is designed to help ProFTPD be case-insensitive, for those
sites that may need it (e.g. those that are migrating from a Windows
environment or have mounted Windows filesystems).

mod_case works by performing two checks on the filename used in FTP commands.
First, mod_case will scan the directory to see if there is already a file whose
name exactly matches the given filename. If not, mod_case will scan the
directory again, this time looking for case-insensitive matches. 

%package	mod_gss
Summary:	A Kerberos 5 GSS module for ProFTPD
Group:		System/Servers
Requires(post): %{name} = %{version}-%{release}
Requires(preun): %{name} = %{version}-%{release}
Requires:	%{name} = %{version}-%{release}

%description	mod_gss
A Kerberos 5 GSS module for ProFTPD

%package	mod_load
Summary:	A module that determines average load for ProFTPD
Group:		System/Servers
Requires(post): %{name} = %{version}-%{release}
Requires(preun): %{name} = %{version}-%{release}
Requires:	%{name} = %{version}-%{release}

%description	mod_load
The code for determining load average on a given system is hairy, to say the
least. Unfortunately, it is necessary to do it this way, as there is no
standard method for extracting such information from the kernel. This module
uses code from GNU's make application, which should function properly. If not,
please contact the author as soon as possible.

%package	mod_shaper
Summary:	A shaping module for ProFTPD
Group:		System/Servers
Requires(post): %{name} = %{version}-%{release}
Requires(preun): %{name} = %{version}-%{release}
Requires:	%{name} = %{version}-%{release}

%description	mod_shaper
The mod_shaper module is designed to split overall rates, both download and
upload, for the proftpd daemon among all connected FTP clients, shaping each
session to use only a portion of the overall rate. mod_shaper shapes both
transmitted traffic, e.g. bits being downloaded via the RETR command, and
received traffic, e.g. bits being uploaded via the APPE, STOR, and STOU
commands.

%package	mod_time
Summary:	Limits acces based on the time of day and/or the day of the week
Group:		System/Servers
Requires(post): %{name} = %{version}-%{release}
Requires(preun): %{name} = %{version}-%{release}
Requires:	%{name} = %{version}-%{release}

%description	mod_time
This module is designed to allow for limiting FTP commands based on the time of
day and/or the day of the week. A more detailed explanation of the usage of
this module follows the directive explanations.

%package	mod_wrap
Summary:	Provides tcpwrapper-like access control rules for ProFTPD
Group:		System/Servers
Requires(post): %{name} = %{version}-%{release}
Requires(preun): %{name} = %{version}-%{release}
Requires:	%{name} = %{version}-%{release}
Requires:	%{name}-mod_wrap_driver = %{version}-%{release}
Requires:	tcp_wrappers

%description	mod_wrap
The mod_wrap package allows the proftpd daemon to provide tcpwrapper-like
access control rules while running in standalone mode. It also allows for those
access rules to be stored in various formats, such as files (e.g.
/etc/hosts.allow and /etc/hosts.deny) or in SQL tables.

The most current version of mod_wrap's submodules supports storage of access
table information in various formats:

 o mod_wrap_file for file-based access tables
 o mod_wrap_sql for SQL-based access tables

%package	mod_wrap_file
Summary:	A file-specific driver for the mod_wrap module for ProFTPD
Group:		System/Servers
Requires(post): %{name} = %{version}-%{release}
Requires(preun): %{name} = %{version}-%{release}
Requires:	%{name} = %{version}-%{release}
Provides:	%{name}-mod_wrap_driver = %{version}-%{release}

%description	mod_wrap_file
This submodule provides the file-specific "driver" for storing IP/DNS-based
access control information in files.

%package	mod_wrap_sql
Summary:	A SQL database driver for the mod_wrap module for ProFTPD
Group:		System/Servers
Requires(post): %{name} = %{version}-%{release}
Requires(preun): %{name} = %{version}-%{release}
Requires:	%{name} = %{version}-%{release}
Provides:	%{name}-mod_wrap_driver = %{version}-%{release}

%description	mod_wrap_sql
This submodule provides the SQL database "driver" for storing IP/DNS-based
access control information in SQL tables.

%package	mod_ban
Summary:	Adds dynamic "ban" lists to ProFTPD
Group:		System/Servers
Requires(post): %{name} = %{version}-%{release}
Requires(preun): %{name} = %{version}-%{release}
Requires:	%{name} = %{version}-%{release}

%description	mod_ban
The mod_ban module is designed to add dynamic "ban" lists to proftpd. A ban
prevents the banned user, host, or class from logging in to the server; it does
not prevent the banned user, host, or class from connecting to the server.
mod_ban is not a firewall. The module also provides automatic bans that are
triggered based on configurable criteria.

%package	mod_vroot
Summary:	Adds virtual chroot capability to ProFTPD
Group:		System/Servers
Requires(post): %{name} = %{version}-%{release}
Requires(preun): %{name} = %{version}-%{release}
Requires:	%{name} = %{version}-%{release}

%description	mod_vroot
The purpose of this module to is to implement a virtual chroot capability that
does not require root privileges. The mod_vroot module provides this capability
by using ProFTPD's FS API, available as of 1.2.8rc1.

%package	mod_sftp
Summary:	Implements the SSH2 protocol and its SFTP subsystem for ProFTPD
Group:		System/Servers
Requires(post): %{name} = %{version}-%{release}
Requires(preun): %{name} = %{version}-%{release}
Requires:	%{name} = %{version}-%{release}

%description	mod_sftp
The mod_sftp module implements the SSH2 protocol and its SFTP subsystem, for
secure file transfer over an SSH2 connection. The mod_sftp module supports:

 o Public key authentication
 o Password authentication (e.g. user authentication via mod_sql, mod_ldap,
   mod_auth_file, mod_auth_unix, mod_auth_pam)
 o SCP support
 o Quotas (via the mod_quotatab module)
 o FIPS support (see Usage section)
 o Throttled transfers (via TransferRate, and/or the mod_shaper module)
 o Blacklisted public keys
 o Configurable traffic analysis protection
 o Passphrase-protected host keys 

%prep

%setup -q -n %{name}-%{version} -a100 -a102 -a103 -a104 -a105 -a108

%patch0 -p0 -b .logfile_location
%patch2 -p0 -b .pam
%patch4 -p1 -b .installfix
%patch7 -p0 -b .change_pam_name
%patch8 -p0 -b .mod_time_fix

%patch40 -p0 -b .format_not_a_string_literal_and_no_format_arguments
%patch41 -p0 -b .format_not_a_string_literal_and_no_format_arguments

# PCLinuxOS config
mkdir -p PCLinuxOS
install -m0644 %{SOURCE1} PCLinuxOS/proftpd.logrotate
install -m0644 %{SOURCE2} PCLinuxOS/proftpd.xinetd
install -m0644 %{SOURCE3} PCLinuxOS/proftpd.init
install -m0644 %{SOURCE4} PCLinuxOS/proftpd.service
install -m0644 %{SOURCE5} PCLinuxOS/basic.conf
install -m0644 %{SOURCE7} PCLinuxOS/welcome.msg
install -m0644 %{SOURCE32} PCLinuxOS/32_mod_shaper.conf

# lib64 fix
perl -pi -e "s|/usr/lib|%{_libdir}|g" PCLinuxOS/basic.conf

# fix includes, instead of a patch
perl -pi -e "s|\<mysql\.h\>|\<mysql\/mysql\.h\>|g" contrib/mod_sql_mysql.c
#perl -pi -e "s|\<libpq-fe\.h\>|\<pgsql\/libpq-fe\.h\>|g" contrib/mod_sql_postgres.c

%build

%serverbuild

export CFLAGS="$CFLAGS -DLDAP_DEPRECATED -DUSE_LDAP_TLS -DHAVE_OPENSSL"
export LIBS="-L%{_libdir} -lattr"

pushd mod_gss-%{mod_gss_version}
perl -pi -e "s|<gssapi.h>|<gssapi/gssapi.h>|" configure*
perl -pi -e "s|NULL,code|kc,code|" *.in
#libtoolize --copy --force --ltdl
#rm -rf lib/libltdl; mv libltdl lib/
#rm -f configure; autoconf
%configure2_5x 
# Workaround a missing dcl in kerberos...
cat >> mod_gss.h <<EOF
#ifndef GSS_C_AF_INET6
#define GSS_C_AF_INET6 24
#endif
EOF
popd

pushd contrib/mod_load
%configure2_5x
popd

pushd contrib/mod_wrap2
%configure2_5x
popd

# put extra modules in place 
for i in `find mod_* -type f -name "*.c"` `find mod_* -type f -name "*.h"`; do
    cp $i contrib/
done

%configure2_5x \
    --libexecdir=%{_libdir}/%{name} \
    --enable-auth-pam \
    --enable-cap \
    --disable-facl \
    --enable-dso \
    --enable-nls \
    --enable-openssl \
    --with-lastlog=/var/log/lastlog \
    --enable-ipv6 \
    --enable-shadow \
    --enable-ctrls \
    --with-shared="mod_ratio:mod_tls:mod_radius:mod_ldap:mod_sql:mod_sql_mysql:mod_sql_postgres:mod_rewrite:mod_load:mod_ctrls_admin:mod_quotatab:mod_quotatab_file:mod_quotatab_ldap:mod_quotatab_sql:mod_quotatab_radius:mod_site_misc:mod_wrap2:mod_wrap2_file:mod_wrap2_sql:mod_autohost:mod_case:mod_shaper:mod_ban:mod_vroot:mod_sftp:mod_time:mod_ifsession" \
    --with-modules="mod_readme:mod_auth_pam"

# libcap hack
perl -pi -e "s|/lib/libcap|/blabla|g" Make.rules
echo "#define HAVE_LINUX_CAPABILITY_H 1" >> config.h

%make

%install
rm -rf %{buildroot}

install -d %{buildroot}%{_initrddir}
install -d %{buildroot}%{_libdir}/%{name}
install -d %{buildroot}%{_sysconfdir}/logrotate.d
install -d %{buildroot}%{_sysconfdir}/%{name}.d
install -d %{buildroot}%{_sysconfdir}/pam.d
install -d %{buildroot}%{_sysconfdir}/xinetd.d
install -d %{buildroot}%{_sysconfdir}/avahi/services
install -d %{buildroot}/var/ftp/pub
install -d %{buildroot}/var/log/%{name}
install -d %{buildroot}/var/run/%{name}

%makeinstall \
    rundir=%{buildroot}/var/run/%{name} \
    LIBEXECDIR=%{buildroot}%{_libdir}/%{name} \
    SHARED_MODULE_DIRS="" \
    INSTALL_USER=`id -un` INSTALL_GROUP=`id -gn` \
    INSTALL="install -p" \
    pkgconfigdir=%{buildroot}%{_libdir}/pkgconfig

# fix borked pkgconfig file
perl -pi -e "s|^prefix.*|prefix=%{_prefix}|g" %{buildroot}%{_libdir}/pkgconfig/*.pc
perl -pi -e "s|/lib/|/%{_lib}/|g" %{buildroot}%{_libdir}/pkgconfig/*.pc

%makeinstall -C contrib/mod_wrap2 LIBEXECDIR=%{buildroot}%{_libdir}/%{name}
%makeinstall -C contrib/mod_load LIBEXECDIR=%{buildroot}%{_libdir}/%{name}
%makeinstall -C contrib/mod_sftp LIBEXECDIR=%{buildroot}%{_libdir}/%{name}

install -m0644 contrib/dist/rpm/ftp.pamd %{buildroot}%{_sysconfdir}/pam.d/%{name}
install -m0755 contrib/xferstats.holger-preiss %{buildroot}%{_sbindir}

install -m0644 PCLinuxOS/proftpd.logrotate %{buildroot}%{_sysconfdir}/logrotate.d/%{name}
install -m0644 PCLinuxOS/proftpd.xinetd %{buildroot}%{_sysconfdir}/xinetd.d/%{name}-xinetd
install -m0755 PCLinuxOS/proftpd.init %{buildroot}%{_initrddir}/%{name}
install -m0644 PCLinuxOS/proftpd.service %{buildroot}%{_sysconfdir}/avahi/services/%{name}.service
install -m0644 PCLinuxOS/basic.conf %{buildroot}%{_sysconfdir}/%{name}.conf
install -m0644 PCLinuxOS/welcome.msg %{buildroot}/var/ftp/pub/welcome.msg

install -m0644 %{SOURCE200} %{buildroot}%{_sysconfdir}/proftpd-anonymous.conf

ln -snf %{name} %{buildroot}%{_sbindir}/in.%{name}
ln -snf %{name} %{buildroot}%{_sbindir}/in.ftpd

# config
echo "LoadModule mod_ctrls_admin.c" > %{buildroot}%{_sysconfdir}/%{name}.d/10_mod_ctrls_admin.conf
echo "LoadModule mod_tls.c" > %{buildroot}%{_sysconfdir}/%{name}.d/11_mod_tls.conf
echo "LoadModule mod_sql.c" > %{buildroot}%{_sysconfdir}/%{name}.d/12_mod_sql.conf
echo "LoadModule mod_ldap.c" > %{buildroot}%{_sysconfdir}/%{name}.d/13_mod_ldap.conf
echo "LoadModule mod_sql_mysql.c" > %{buildroot}%{_sysconfdir}/%{name}.d/14_mod_sql_mysql.conf
echo "LoadModule mod_sql_postgres.c" > %{buildroot}%{_sysconfdir}/%{name}.d/15_mod_sql_postgres.conf
echo "LoadModule mod_quotatab.c" > %{buildroot}%{_sysconfdir}/%{name}.d/16_mod_quotatab.conf
echo "LoadModule mod_quotatab_file.c" > %{buildroot}%{_sysconfdir}/%{name}.d/17_mod_quotatab_file.conf
echo "LoadModule mod_quotatab_ldap.c" > %{buildroot}%{_sysconfdir}/%{name}.d/18_mod_quotatab_ldap.conf
echo "LoadModule mod_quotatab_sql.c" > %{buildroot}%{_sysconfdir}/%{name}.d/19_mod_quotatab_sql.conf
echo "LoadModule mod_quotatab_radius.c" > %{buildroot}%{_sysconfdir}/%{name}.d/20_mod_quotatab_radius.conf
echo "LoadModule mod_radius.c" > %{buildroot}%{_sysconfdir}/%{name}.d/20_mod_radius.conf
echo "LoadModule mod_wrap2.c" > %{buildroot}%{_sysconfdir}/%{name}.d/21_mod_wrap2.conf
echo "LoadModule mod_wrap2_file.c" > %{buildroot}%{_sysconfdir}/%{name}.d/22_mod_wrap2_file.conf
echo "LoadModule mod_wrap2_sql.c" > %{buildroot}%{_sysconfdir}/%{name}.d/23_mod_wrap2_sql.conf
echo "LoadModule mod_rewrite.c" > %{buildroot}%{_sysconfdir}/%{name}.d/24_mod_rewrite.conf
echo "LoadModule mod_ratio.c" > %{buildroot}%{_sysconfdir}/%{name}.d/25_mod_ratio.conf
#echo "LoadModule mod_gss.c" > %{buildroot}%{_sysconfdir}/%{name}.d/26_mod_gss.conf
echo "LoadModule mod_autohost.c" > %{buildroot}%{_sysconfdir}/%{name}.d/27_mod_autohost.conf
echo "LoadModule mod_case.c" > %{buildroot}%{_sysconfdir}/%{name}.d/28_mod_case.conf
#echo "LoadModule mod_facl.c" > %{buildroot}%{_sysconfdir}/%{name}.d/30_mod_facl.conf
echo "LoadModule mod_load.c" > %{buildroot}%{_sysconfdir}/%{name}.d/31_mod_load.conf
install -m0644 PCLinuxOS/32_mod_shaper.conf %{buildroot}%{_sysconfdir}/%{name}.d/32_mod_shaper.conf
echo "LoadModule mod_site_misc.c" > %{buildroot}%{_sysconfdir}/%{name}.d/33_mod_site_misc.conf
echo "LoadModule mod_time.c" > %{buildroot}%{_sysconfdir}/%{name}.d/34_mod_time.conf
echo "LoadModule mod_ban.c" > %{buildroot}%{_sysconfdir}/%{name}.d/35_mod_ban.conf
echo "LoadModule mod_vroot.c" > %{buildroot}%{_sysconfdir}/%{name}.d/36_mod_vroot.conf
echo "LoadModule mod_sftp.c" > %{buildroot}%{_sysconfdir}/%{name}.d/37_mod_sftp.conf

cat > %{buildroot}%{_sysconfdir}/%{name}.d/99_mod_ifsession.conf << EOF
# keep this module the last one
LoadModule mod_ifsession.c
EOF

cat > README.pclos << EOF
PCLinuxOS RPM specific notes

modules support
---------------
proftpd-1.3.0 now loads the modules dynamically, very few modules are compiled
into the proftpd binary. The new configuration file /etc/proftpd.conf uses a
"Include /etc/proftpd.d/*.conf" statement which makes proftpd very similar to
how modules are loaded and the configuration of apache-2.x. Because of this you
may have to manually merge your old configuration into the new
/etc/proftpd.conf file.  This is especially true if you are using LDAP, because
then the mod_ldap.so proftpd module will not be automatically loaded. Here is a
list of the modules that are compiled as DSO's:

 o mod_autohost.so         <- NEW
 o mod_ban.so              <- NEW
 o mod_case.so             <- NEW
 o mod_ctrls_admin.so      <- NEW
 o mod_facl.so
 o mod_ifsession.so
 o mod_ldap.so
 o mod_load.so             <- NEW
 o mod_quotatab.so         <- NEW
 o mod_quotatab_file.so    <- NEW
 o mod_quotatab_ldap.so    <- NEW
 o mod_quotatab_sql.so     <- NEW
 o mod_quotatab_radius.so  <- NEW
 o mod_radius.so
 o mod_ratio.so
 o mod_rewrite.so
 o mod_shaper.so           <- NEW
 o mod_site_misc.so        <- NEW
 o mod_sql.so              <- NEW
 o mod_sql_mysql.so        <- NEW
 o mod_sql_postgres.so     <- NEW
 o mod_time.so             <- NEW
 o mod_tls.so
 o mod_wrap2.so            <- NEW
 o mod_wrap2_file.so       <- NEW
 o mod_wrap2_sql.so        <- NEW
 o mod_vroot.so            <- NEW
 o mod_sftp                <- NEW
 
anonymous access configuration
------------------------------
Starting with 1.3.0-3, there is no proftpd-anonymous package anymore.
As it is just a configuration issue, providing a dedicated package was a bit
overkill. Samples configuration files are available among normal package
documentation. You may have to update your configuration manually.
EOF


%find_lang %{name}

# cleanup
rm -f %{buildroot}%{_libdir}/%{name}/*.{a,la}
rm -f contrib/README.mod_sql contrib/README.linux-privs

%post
%_post_service %{name}

# xinetd reset
# Only do it if xinetd is there. -- Geoff
if [ -x /usr/sbin/xinetd ];then
%_post_service xinetd
fi

# ftpusers creation
if [ ! -f %{_sysconfdir}/ftpusers ]; then
    touch %{_sysconfdir}/ftpusers
fi

USERS="root bin daemon adm lp sync shutdown halt mail news uucp operator games nobody"
for i in $USERS ;do
        cat %{_sysconfdir}/ftpusers | grep -q "^$i$" || echo $i >> %{_sysconfdir}/ftpusers
done

%pre
%_pre_useradd ftp /var/ftp /bin/false

%postun
%_postun_userdel ftp

%preun
%_preun_service %{name}
if [ "$1" = 0 ]; then
 if [ -d /var/run/%{name} ]; then
  rm -rf /var/run/%{name}/*
 fi
fi

if [ -x /usr/sbin/xinetd ];then
%_post_service xinetd
fi

%post -n %{name}-mod_autohost
service proftpd condrestart > /dev/null 2>/dev/null || :
    
%preun -n %{name}-mod_autohost
if [ "$1" = 0 ]; then
    service proftpd condrestart > /dev/null 2>/dev/null || :
fi

%post -n %{name}-mod_case
service proftpd condrestart > /dev/null 2>/dev/null || :
    
%preun -n %{name}-mod_case
if [ "$1" = 0 ]; then
    service proftpd condrestart > /dev/null 2>/dev/null || :
fi

%post -n %{name}-mod_ctrls_admin
service proftpd condrestart > /dev/null 2>/dev/null || :
    
%preun -n %{name}-mod_ctrls_admin
if [ "$1" = 0 ]; then
    service proftpd condrestart > /dev/null 2>/dev/null || :
fi

%post -n %{name}-mod_gss
service proftpd condrestart > /dev/null 2>/dev/null || :
    
%preun -n %{name}-mod_gss
if [ "$1" = 0 ]; then
    service proftpd condrestart > /dev/null 2>/dev/null || :
fi

%post -n %{name}-mod_ifsession
service proftpd condrestart > /dev/null 2>/dev/null || :
    
%preun -n %{name}-mod_ifsession
if [ "$1" = 0 ]; then
    service proftpd condrestart > /dev/null 2>/dev/null || :
fi

%post -n %{name}-mod_ldap
service proftpd condrestart > /dev/null 2>/dev/null || :
    
%preun -n %{name}-mod_ldap
if [ "$1" = 0 ]; then
    service proftpd condrestart > /dev/null 2>/dev/null || :
fi

%post -n %{name}-mod_load
service proftpd condrestart > /dev/null 2>/dev/null || :
    
%preun -n %{name}-mod_load
if [ "$1" = 0 ]; then
    service proftpd condrestart > /dev/null 2>/dev/null || :
fi

%post -n %{name}-mod_quotatab
service proftpd condrestart > /dev/null 2>/dev/null || :
    
%preun -n %{name}-mod_quotatab
if [ "$1" = 0 ]; then
    service proftpd condrestart > /dev/null 2>/dev/null || :
fi

%post -n %{name}-mod_quotatab_file
service proftpd condrestart > /dev/null 2>/dev/null || :
    
%preun -n %{name}-mod_quotatab_file
if [ "$1" = 0 ]; then
    service proftpd condrestart > /dev/null 2>/dev/null || :
fi

%post -n %{name}-mod_quotatab_ldap
service proftpd condrestart > /dev/null 2>/dev/null || :
    
%preun -n %{name}-mod_quotatab_ldap
if [ "$1" = 0 ]; then
    service proftpd condrestart > /dev/null 2>/dev/null || :
fi

%post -n %{name}-mod_quotatab_sql
service proftpd condrestart > /dev/null 2>/dev/null || :
    
%preun -n %{name}-mod_quotatab_sql
if [ "$1" = 0 ]; then
    service proftpd condrestart > /dev/null 2>/dev/null || :
fi

%post -n %{name}-mod_quotatab_radius
service proftpd condrestart > /dev/null 2>/dev/null || :
    
%preun -n %{name}-mod_quotatab_radius
if [ "$1" = 0 ]; then
    service proftpd condrestart > /dev/null 2>/dev/null || :
fi

%post -n %{name}-mod_radius
service proftpd condrestart > /dev/null 2>/dev/null || :
    
%preun -n %{name}-mod_radius
if [ "$1" = 0 ]; then
    service proftpd condrestart > /dev/null 2>/dev/null || :
fi

%post -n %{name}-mod_ratio
service proftpd condrestart > /dev/null 2>/dev/null || :
    
%preun -n %{name}-mod_ratio
if [ "$1" = 0 ]; then
    service proftpd condrestart > /dev/null 2>/dev/null || :
fi

%post -n %{name}-mod_rewrite
service proftpd condrestart > /dev/null 2>/dev/null || :
    
%preun -n %{name}-mod_rewrite
if [ "$1" = 0 ]; then
    service proftpd condrestart > /dev/null 2>/dev/null || :
fi

%post -n %{name}-mod_shaper
service proftpd condrestart > /dev/null 2>/dev/null || :
    
%preun -n %{name}-mod_shaper
if [ "$1" = 0 ]; then
    service proftpd condrestart > /dev/null 2>/dev/null || :
fi

%post -n %{name}-mod_site_misc
service proftpd condrestart > /dev/null 2>/dev/null || :
    
%preun -n %{name}-mod_site_misc
if [ "$1" = 0 ]; then
    service proftpd condrestart > /dev/null 2>/dev/null || :
fi

%post -n %{name}-mod_sql_mysql
service proftpd condrestart > /dev/null 2>/dev/null || :
    
%preun -n %{name}-mod_sql_mysql
if [ "$1" = 0 ]; then
    service proftpd condrestart > /dev/null 2>/dev/null || :
fi

%post -n %{name}-mod_sql
service proftpd condrestart > /dev/null 2>/dev/null || :
    
%preun -n %{name}-mod_sql
if [ "$1" = 0 ]; then
    service proftpd condrestart > /dev/null 2>/dev/null || :
fi

%post -n %{name}-mod_time
service proftpd condrestart > /dev/null 2>/dev/null || :

%preun -n %{name}-mod_time
if [ "$1" = 0 ]; then
    service proftpd condrestart > /dev/null 2>/dev/null || :
fi

%post -n %{name}-mod_tls
service proftpd condrestart > /dev/null 2>/dev/null || :
    
%preun -n %{name}-mod_tls
if [ "$1" = 0 ]; then
    service proftpd condrestart > /dev/null 2>/dev/null || :
fi

%post -n %{name}-mod_wrap_file
service proftpd condrestart > /dev/null 2>/dev/null || :
    
%preun -n %{name}-mod_wrap_file
if [ "$1" = 0 ]; then
    service proftpd condrestart > /dev/null 2>/dev/null || :
fi

%post -n %{name}-mod_wrap
service proftpd condrestart > /dev/null 2>/dev/null || :
    
%preun -n %{name}-mod_wrap
if [ "$1" = 0 ]; then
    service proftpd condrestart > /dev/null 2>/dev/null || :
fi

%post -n %{name}-mod_wrap_sql
service proftpd condrestart > /dev/null 2>/dev/null || :
    
%preun -n %{name}-mod_wrap_sql
if [ "$1" = 0 ]; then
    service proftpd condrestart > /dev/null 2>/dev/null || :
fi

%post -n %{name}-mod_ban
service proftpd condrestart > /dev/null 2>/dev/null || :
    
%preun -n %{name}-mod_ban
if [ "$1" = 0 ]; then
    service proftpd condrestart > /dev/null 2>/dev/null || :
fi

%post -n %{name}-mod_vroot
service proftpd condrestart > /dev/null 2>/dev/null || :
    
%preun -n %{name}-mod_vroot
if [ "$1" = 0 ]; then
    service proftpd condrestart > /dev/null 2>/dev/null || :
fi

%post -n %{name}-mod_sftp
service proftpd condrestart > /dev/null 2>/dev/null || :
    
%preun -n %{name}-mod_sftp
if [ "$1" = 0 ]; then
    service proftpd condrestart > /dev/null 2>/dev/null || :
fi

%triggerpostun -- proftpd-anonymous
# this package doesn't exist anymore, but its configuration file may
# be used in current proftpd configuration
if [ -e /etc/proftpd-anonymous.conf.rpmsave ]; then
    mv -f /etc/proftpd-anonymous.conf.rpmsave /etc/proftpd-anonymous.conf
    echo "warning: /etc/proftpd-anonymous.conf.rpmsave restored as /etc/proftpd-anonymous.conf"
fi

%clean
rm -rf %{buildroot}

%files -f %{name}.lang
%defattr(-,root,root)
%doc README* INSTALL NEWS CREDITS COPYING doc/* README.pclos
%doc sample-configurations/*
%dir %{_sysconfdir}/proftpd.d
%config(noreplace) %{_sysconfdir}/%{name}.conf
%config(noreplace) %{_sysconfdir}/%{name}-anonymous.conf
%config(noreplace) %{_sysconfdir}/pam.d/%{name}
%config(noreplace) %{_sysconfdir}/xinetd.d/%{name}-xinetd
%config(noreplace) %{_sysconfdir}/logrotate.d/%{name}
%config(noreplace) %{_sysconfdir}/avahi/services/%{name}.service
%{_initrddir}/%{name}
%{_sbindir}/%{name}
%{_sbindir}/ftpscrub
%{_sbindir}/ftpshut
%{_sbindir}/in.ftpd
%{_sbindir}/in.%{name}
%{_sbindir}/xferstats.holger-preiss
%{_bindir}/ftpasswd
%{_bindir}/ftpcount
%{_bindir}/ftpdctl
%{_bindir}/ftpmail
%{_bindir}/ftptop
%{_bindir}/ftpwho
%{_bindir}/ftpquota
%{_bindir}/prxs
%dir %{_libdir}/%{name}
%dir /var/ftp
%dir /var/ftp/pub
%config(noreplace) /var/ftp/pub/welcome.msg
%dir /var/run/%{name}
%dir /var/log/%{name}
%{_mandir}/man*/*

%files devel
%defattr(-,root,root)
%doc ChangeLog
%dir %{_includedir}/%{name}
%{_includedir}/%{name}/*.h
%{_libdir}/pkgconfig/*.pc

%files mod_ctrls_admin
%defattr(-,root,root)
%doc doc/contrib/mod_ctrls_admin.html
%config(noreplace) %{_sysconfdir}/%{name}.d/10_mod_ctrls_admin.conf
%{_libdir}/%{name}/mod_ctrls_admin.so

%files mod_ifsession
%defattr(-,root,root)
%doc doc/contrib/mod_ifsession.html
%config(noreplace) %{_sysconfdir}/%{name}.d/99_mod_ifsession.conf
%{_libdir}/%{name}/mod_ifsession.so

%files mod_ldap
%defattr(-,root,root)
%config(noreplace) %{_sysconfdir}/%{name}.d/13_mod_ldap.conf
%{_libdir}/%{name}/mod_ldap.so

%files mod_quotatab
%defattr(-,root,root)
%doc doc/contrib/mod_quotatab.html
%config(noreplace) %{_sysconfdir}/%{name}.d/16_mod_quotatab.conf
%{_libdir}/%{name}/mod_quotatab.so

%files mod_quotatab_file
%defattr(-,root,root)
%doc doc/contrib/mod_quotatab_file.html
%config(noreplace) %{_sysconfdir}/%{name}.d/17_mod_quotatab_file.conf
%{_libdir}/%{name}/mod_quotatab_file.so

%files mod_quotatab_ldap
%defattr(-,root,root)
%doc doc/contrib/mod_quotatab_ldap.html
%config(noreplace) %{_sysconfdir}/%{name}.d/18_mod_quotatab_ldap.conf
%{_libdir}/%{name}/mod_quotatab_ldap.so

%files mod_quotatab_sql
%defattr(-,root,root)
%doc doc/contrib/mod_quotatab_sql.html
%config(noreplace) %{_sysconfdir}/%{name}.d/19_mod_quotatab_sql.conf
%{_libdir}/%{name}/mod_quotatab_sql.so

%files mod_quotatab_radius
%defattr(-,root,root)
%doc doc/contrib/mod_quotatab_radius.html
%config(noreplace) %{_sysconfdir}/%{name}.d/20_mod_quotatab_radius.conf
%{_libdir}/%{name}/mod_quotatab_radius.so

%files mod_radius
%defattr(-,root,root)
%doc doc/contrib/mod_radius.html
%config(noreplace) %{_sysconfdir}/%{name}.d/20_mod_radius.conf
%{_libdir}/%{name}/mod_radius.so

%files mod_ratio
%defattr(-,root,root)
%doc contrib/README.ratio
%config(noreplace) %{_sysconfdir}/%{name}.d/25_mod_ratio.conf
%{_libdir}/%{name}/mod_ratio.so

%files mod_rewrite
%defattr(-,root,root)
%doc doc/contrib/mod_rewrite.html
%config(noreplace) %{_sysconfdir}/%{name}.d/24_mod_rewrite.conf
%{_libdir}/%{name}/mod_rewrite.so

%files mod_site_misc
%defattr(-,root,root)
%doc doc/contrib/mod_site_misc.html
%config(noreplace) %{_sysconfdir}/%{name}.d/33_mod_site_misc.conf
%{_libdir}/%{name}/mod_site_misc.so

%files mod_sql
%defattr(-,root,root)
%doc doc/contrib/mod_sql.html
%config(noreplace) %{_sysconfdir}/%{name}.d/12_mod_sql.conf
%{_libdir}/%{name}/mod_sql.so

%files mod_sql_mysql
%defattr(-,root,root)
%config(noreplace) %{_sysconfdir}/%{name}.d/14_mod_sql_mysql.conf
%{_libdir}/%{name}/mod_sql_mysql.so

%files mod_sql_postgres
%defattr(-,root,root)
%config(noreplace) %{_sysconfdir}/%{name}.d/15_mod_sql_postgres.conf
%{_libdir}/%{name}/mod_sql_postgres.so

%files mod_tls
%defattr(-,root,root)
%doc doc/contrib/mod_tls.html
%config(noreplace) %{_sysconfdir}/%{name}.d/11_mod_tls.conf
%{_libdir}/%{name}/mod_tls.so

%files mod_autohost
%defattr(-,root,root)
%doc mod_autohost/mod_autohost.html
%config(noreplace) %{_sysconfdir}/%{name}.d/27_mod_autohost.conf
%{_libdir}/%{name}/mod_autohost.so

%files mod_case
%defattr(-,root,root)
%doc mod_case/mod_case.html
%config(noreplace) %{_sysconfdir}/%{name}.d/28_mod_case.conf
%{_libdir}/%{name}/mod_case.so

%files mod_gss
%defattr(-,root,root)
%doc mod_gss-*/COPYING mod_gss-*/mod_gss.html mod_gss-*/README.mod_gss mod_gss-*/rfc1509.txt mod_gss-*/rfc2228.txt
#%config(noreplace) %{_sysconfdir}/%{name}.d/26_mod_gss.conf
#%{_libdir}/%{name}/mod_gss.so

%files mod_load
%defattr(-,root,root)
%doc doc/contrib/mod_load.html
%config(noreplace) %{_sysconfdir}/%{name}.d/31_mod_load.conf
%{_libdir}/%{name}/mod_load.so

%files mod_shaper
%defattr(-,root,root)
%doc mod_shaper/mod_shaper.html
%config(noreplace) %{_sysconfdir}/%{name}.d/32_mod_shaper.conf
%{_libdir}/%{name}/mod_shaper.so

%files mod_time
%defattr(-,root,root)
%doc mod_time/README mod_time/mod_time.html
%config(noreplace) %{_sysconfdir}/%{name}.d/34_mod_time.conf
%{_libdir}/%{name}/mod_time.so

%files mod_wrap
%defattr(-,root,root)
%doc doc/contrib/mod_wrap2.html
%config(noreplace) %{_sysconfdir}/%{name}.d/21_mod_wrap2.conf
%{_libdir}/%{name}/mod_wrap2.so

%files mod_wrap_file
%defattr(-,root,root)
%doc doc/contrib/mod_wrap2_file.html
%config(noreplace) %{_sysconfdir}/%{name}.d/22_mod_wrap2_file.conf
%{_libdir}/%{name}/mod_wrap2_file.so

%files mod_wrap_sql
%defattr(-,root,root)
%doc doc/contrib/mod_wrap2_sql.html
%config(noreplace) %{_sysconfdir}/%{name}.d/23_mod_wrap2_sql.conf
%{_libdir}/%{name}/mod_wrap2_sql.so

%files mod_ban
%defattr(-,root,root)
%doc doc/contrib/mod_ban.html
%config(noreplace) %{_sysconfdir}/%{name}.d/35_mod_ban.conf
%{_libdir}/%{name}/mod_ban.so

%files mod_vroot
%defattr(-,root,root)
%doc mod_vroot/mod_vroot.html
%config(noreplace) %{_sysconfdir}/%{name}.d/36_mod_vroot.conf
%{_libdir}/%{name}/mod_vroot.so

%files mod_sftp
%defattr(-,root,root)
%doc doc/contrib/mod_sftp.html
%config(noreplace) %{_sysconfdir}/blacklist.dat
%config(noreplace) %{_sysconfdir}/dhparams.pem
%config(noreplace) %{_sysconfdir}/%{name}.d/37_mod_sftp.conf
%{_libdir}/%{name}/mod_sftp.so


%changelog
* Wed Jun 04 2014 bb <bb> 1.3.4e-1pclos2014
- update

* Wed Jun 19 2013 Texstar <texstar at gmail.com> 1.3.4d-1pclos2013
- update

* Sat May 18 2013 pinoc <vogtpet at gmail.com> 1.3.4c-2pclos2013
- removed urpmi references

* Wed Mar 06 2013 ghostbunny <hmhaase at pclinuxosusers dot de> 1.3.4c-1pclos2013
- 1.3.4c
- updated mod_gss to 1.3.5
- updated mod_vroot to 0.9.2
- updated mod_case to 0.7
- updated mod_autohost to 0.4
- added xz compression for mod sources
- replaced occurrences of Mandriva by PCLinuxOS
- fix patch4, 7, 40
- removed patch9 applied in source

